// BonDriverProxy.cpp: BonDriverNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "BonDriverProxy.h"


/////////////////////////////////////////////////////////////////////////////
// BonDriver - IHalTsTunerϊNX
/////////////////////////////////////////////////////////////////////////////

// IBonDriver
const BOOL CBonDriverProxy::OpenTuner(void)
{
	// `[iI[v
	const BOOL bReturn = (m_pTsTuner->OpenTuner())? TRUE : FALSE;

	// LNBd͕KONƂ
	if(bReturn)m_pTsTuner->SetLnbPower(true);

	// I[vtOZbg
	m_bIsOpen = bReturn;

	return bReturn;
}

void CBonDriverProxy::CloseTuner(void)
{
	// `[i
	m_pTsTuner->CloseTuner();
	
	// I[vtONA
	m_bIsOpen = FALSE;
}

const BOOL CBonDriverProxy::SetChannel(const BYTE bCh)
{
	// `[jOԂ̎w肪oȂߔΉƂ
	::BON_ASSERT(false, TEXT("IBonDriver::SetChannel()͎Ă܂"));
	
	return FALSE;
}

const float CBonDriverProxy::GetSignalLevel(void)
{
	// CNRԂ
	return m_pTsTuner->GetSignalLevel();
}

const DWORD CBonDriverProxy::WaitTsStream(const DWORD dwTimeOut)
{
	// Xg[EFCg
	switch(m_pTsTuner->WaitStream(dwTimeOut)){
		case CSmartEvent::WE_CLOSED :
			// nhꂽ
			return WAIT_ABANDONED;

		case CSmartEvent::WE_TRIGGER :
			// CxggK
			return (GetReadyCount())? WAIT_OBJECT_0 : WAIT_ABANDONED;
		
		case CSmartEvent::WE_TIMEOUT :
			// ^CAEg
			return WAIT_TIMEOUT;

		default:
			// O
			return WAIT_FAILED;
		}
}

const DWORD CBonDriverProxy::GetReadyCount(void)
{
	// o\Xg[Ԃ
	return m_pTsTuner->GetAvailableNum();
}

const BOOL CBonDriverProxy::GetTsStream(BYTE *pDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	// Xg[擾
	BYTE *pData = NULL;
	DWORD dwSize = 0UL;
	DWORD dwRemain = 0UL;
	
	// Xg[|C^擾
	if(!m_pTsTuner->GetStream(&pData, &dwSize, &dwRemain))return FALSE;
	
	// Xg[Rs[
	if(pDst && pdwSize)::CopyMemory(pDst, pData, dwSize);
	if(pdwSize)*pdwSize = dwSize;
	if(pdwRemain)*pdwRemain = dwRemain;
	
	return TRUE;
}

const BOOL CBonDriverProxy::GetTsStream(BYTE **ppDst, DWORD *pdwSize, DWORD *pdwRemain)
{
	// Xg[|C^擾
	return (m_pTsTuner->GetStream(ppDst, pdwSize, pdwRemain))? TRUE : FALSE;
}

void CBonDriverProxy::PurgeTsStream(void)
{
	// ̃Xg[j
	m_pTsTuner->PurgeStream();
}

// IBonDriver2
LPCTSTR CBonDriverProxy::GetTunerName(void)
{
	static TCHAR szTunerName[1024];
	
	// `[iԂ(obt@pĂ邽ߑ̃CX^Xɂe)
	return (dynamic_cast<IHalDevice *>(m_pTsTuner)->GetDeviceName(szTunerName))? szTunerName : NULL;
}

const BOOL CBonDriverProxy::IsTunerOpening(void)
{
	// I[v̗LԂ
	return m_bIsOpen;
}

LPCTSTR CBonDriverProxy::EnumTuningSpace(const DWORD dwSpace)
{
	static TCHAR szSpaceName[1024];
	
	// `[jOԖԂ(obt@pĂ邽ߑ̃CX^Xɂe)
	return (m_pTsTuner->EnumTuningSpace(dwSpace, szSpaceName))? szSpaceName : NULL;
}

LPCTSTR CBonDriverProxy::EnumChannelName(const DWORD dwSpace, const DWORD dwChannel)
{
	static TCHAR szChannelName[1024];
	
	// `lԂ(obt@pĂ邽ߑ̃CX^Xɂe)
	return (m_pTsTuner->EnumChannelName(dwSpace, dwChannel, szChannelName))? szChannelName : NULL;
}

const BOOL CBonDriverProxy::SetChannel(const DWORD dwSpace, const DWORD dwChannel)
{
	// `lύX
	return (m_pTsTuner->SetChannel(dwSpace, dwChannel))? TRUE : FALSE;
}

const DWORD CBonDriverProxy::GetCurSpace(void)
{
	// ݂̃`[jOԂԂ
	return m_pTsTuner->GetCurSpace();
}

const DWORD CBonDriverProxy::GetCurChannel(void)
{
	// ݂̃`lԂ
	return m_pTsTuner->GetCurChannel();
}

// IBonDriver3
const DWORD CBonDriverProxy::GetTotalDeviceNum(void)
{
	// foCX̑Ԃ
	return dynamic_cast<IHalDevice *>(m_pTsTuner)->GetTotalDeviceNum();
}

const DWORD CBonDriverProxy::GetActiveDeviceNum(void)
{
	// gp̃foCXԂ
	return dynamic_cast<IHalDevice *>(m_pTsTuner)->GetActiveDeviceNum();
}

CBonDriverProxy::CBonDriverProxy(LPCTSTR lpszClassName)
	: m_pTsTuner(::BON_SAFE_CREATE<IHalTsTuner *>(lpszClassName))
	, m_bIsOpen(FALSE)
{
	// `[iCX^XmF
	::BON_ASSERT(m_pTsTuner != NULL, TEXT("BonNX %s ̃CX^X𐶐ł܂"), lpszClassName);
}

CBonDriverProxy::~CBonDriverProxy()
{
	// `[iCX^XJ
	BON_SAFE_RELEASE(m_pTsTuner);
}

void CBonDriverProxy::Release(void)
{
	// CX^XJ
	delete this;
}
