// Pt1Manager.h: PT1foCXǗNX
//
/////////////////////////////////////////////////////////////////////////////

#pragma once


#include "EARTH_PT.h"
#include "OS_Library.h"
#include <Map>


using namespace EARTH;
using namespace OS;
using namespace PT;


/////////////////////////////////////////////////////////////////////////////
// PT1foCXǗNX
/////////////////////////////////////////////////////////////////////////////

class CPt1Manager
{
public:
	enum{TUNER_NUM = 2UL};

	// `[iReLXg
	struct TUNER_CONTEXT
	{
		Device::ISDB TunerType;		// ISDB-T or ISDB-S
		Device *pDevice;			// foCXCX^X
		DWORD dwBoardID;			// {[hID
		DWORD dwTunerID;			// `[iID
	};

	CPt1Manager(void);
	virtual ~CPt1Manager(void);

	const DWORD GetTotalDeviceNum(const Device::ISDB TunerType);
	const DWORD GetActiveDeviceNum(const Device::ISDB TunerType);

	const bool OpenDevice(TUNER_CONTEXT *pTunerContext, const Device::ISDB TunerType);
	void CloseDevice(const TUNER_CONTEXT *pTunerContext);

protected:
	const bool OpenManager(void);
	void CloseManager(void);

	const bool OpenBoard(Device *pDevice);
	void CloseBoard(Device *pDevice);

	// PT1foCX
	struct PT1_DEVICE_STAT
	{
		bool aabOpenState[TUNER_NUM][Device::ISDB_COUNT];	// I[vL
		DWORD adwOpenNum[Device::ISDB_COUNT];				// I[v
	};

	typedef std::map<Device *, PT1_DEVICE_STAT> DeviceMap;

	Library m_Library;
	Bus *m_pPtBus;
	DeviceMap m_DeviceMap;
};
