// Pt1Manager.cpp: PT1foCXǗNX
//
/////////////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "BonSDK.h"
#include "Pt1Manager.h"
#include <MmSystem.h>


#pragma comment(lib, "WinMm.lib")


/////////////////////////////////////////////////////////////////////////////
// PT1foCXǗNX
/////////////////////////////////////////////////////////////////////////////

CPt1Manager::CPt1Manager(void)
	: m_pPtBus(NULL)
{
	// ^C}
	::timeBeginPeriod(1UL);

	// }l[WI[v
	OpenManager();
}

CPt1Manager::~CPt1Manager(void)
{
	// }l[WN[Y
	CloseManager();

	// ^C}J
	::timeEndPeriod(1UL);
}

const DWORD CPt1Manager::GetTotalDeviceNum(const Device::ISDB TunerType)
{
	// w肵ނ̃`[iԂ
	return m_DeviceMap.size() * TUNER_NUM * Device::ISDB_COUNT;
}

const DWORD CPt1Manager::GetActiveDeviceNum(const Device::ISDB TunerType)
{
	DWORD dwDeviceNum = 0UL;

	// w肵ނ̎gp`[iԂ
	for(DeviceMap::iterator itDevice = m_DeviceMap.begin() ; itDevice != m_DeviceMap.end() ; itDevice++){
		// {[h
		for(DWORD dwTunerID = 0UL ; dwTunerID < TUNER_NUM ; dwTunerID++){		
			// `[i
			if(itDevice->second.aabOpenState[dwTunerID][TunerType]){
				dwDeviceNum++;
				}
			}
		}

	return dwDeviceNum;
}

const bool CPt1Manager::OpenDevice(TUNER_CONTEXT *pTunerContext, const Device::ISDB TunerType)
{
	if((TunerType >= Device::ISDB_COUNT) || !pTunerContext)::DebugBreak();

	// w肵ނ̃`[ifoCXI[v
	DWORD dwBoardID = 0UL;
	
	for(DeviceMap::iterator itDevice = m_DeviceMap.begin() ; itDevice != m_DeviceMap.end() ; itDevice++, dwBoardID++){
		if(itDevice->second.adwOpenNum[TunerType] < TUNER_NUM){
			// Y{[h̃`[iɋ󂫂
			if(!itDevice->second.adwOpenNum[Device::ISDB_T] && !itDevice->second.adwOpenNum[Device::ISDB_S]){
				// `[iJĂȂ̂ŁA{[hI[v
				if(!OpenBoard(itDevice->first))return false;
				}
			
			// 󂢂Ă`[i
			for(DWORD dwTunerID = 0UL ; dwTunerID < TUNER_NUM ; dwTunerID++){
				if(!itDevice->second.aabOpenState[dwTunerID][TunerType]){
					// foCXԍXV
					itDevice->second.aabOpenState[dwTunerID][TunerType] = true;
					itDevice->second.adwOpenNum[TunerType]++;

					// ReLXgZbg
					pTunerContext->TunerType = TunerType;
					pTunerContext->pDevice = itDevice->first;
					pTunerContext->dwBoardID = dwBoardID;
					pTunerContext->dwTunerID = dwTunerID;

					return true;
					}
				}
			
			// ɗ邱Ƃ͂Ȃ
			::DebugBreak();
			}
		}

	// foCXɋ󂫂Ȃ
	return false;
}

void CPt1Manager::CloseDevice(const TUNER_CONTEXT *pTunerContext)
{
	if(!pTunerContext)::DebugBreak();

	// w肵ނ̃`[ifoCXN[Y
	if(m_DeviceMap[pTunerContext->pDevice].aabOpenState[pTunerContext->dwTunerID][pTunerContext->TunerType]){
		// foCXԍXV
		m_DeviceMap[pTunerContext->pDevice].aabOpenState[pTunerContext->dwTunerID][pTunerContext->TunerType] = false;
		m_DeviceMap[pTunerContext->pDevice].adwOpenNum[pTunerContext->TunerType]--;
		
		if(!m_DeviceMap[pTunerContext->pDevice].adwOpenNum[Device::ISDB_T] && !m_DeviceMap[pTunerContext->pDevice].adwOpenNum[Device::ISDB_S]){
			// `[iJĂȂ̂ŁA{[hN[Y
			CloseBoard(pTunerContext->pDevice);
			}
		}
}

const bool CPt1Manager::OpenManager(void)
{
	// UN[Y
	CloseManager();

	try{
		// BusCX^Xt@Ng[擾
		Bus::NewBusFunction pfnBusFactory = m_Library.Function();
		if(!pfnBusFactory)throw __LINE__;

		// BusCX^X
		if(pfnBusFactory(&m_pPtBus) != STATUS_OK)throw __LINE__;
		
		// PT1{[h
		Bus::DeviceInfo DeviceInfo[8];
		uint nDeviceInfoNum = sizeof(DeviceInfo) / sizeof(DeviceInfo[0]);
		
		if(m_pPtBus->Scan(DeviceInfo, &nDeviceInfoNum) != STATUS_OK)throw __LINE__;
		if(!nDeviceInfoNum)throw __LINE__;

		// PT1foCXCX^X
		for(uint nPos = 0UL ; nPos < nDeviceInfoNum ; nPos++){
			// SĂPT1{[h̃foCXCX^X𐶐
			Device *pNewDevice = NULL;
			PT1_DEVICE_STAT DeviceStat;
			::ZeroMemory(&DeviceStat, sizeof(DeviceStat));
			
			if(m_pPtBus->NewDevice(&DeviceInfo[nPos], &pNewDevice) != STATUS_OK)throw __LINE__;
			if(!pNewDevice)throw __LINE__;
			
			// }bvɒǉ
			m_DeviceMap[pNewDevice] = DeviceStat;
			}
		}
	catch(...){
		// G[
		CloseManager();
		return false;
		}
	
	return true;
}

void CPt1Manager::CloseManager(void)
{
	// DeviceCX^XJ
	for(DeviceMap::iterator itDevice = m_DeviceMap.begin() ; itDevice != m_DeviceMap.end() ; itDevice++){
		itDevice->first->Delete();
		}
	m_DeviceMap.clear();

	// BusCX^XJ
	if(m_pPtBus){
		m_pPtBus->Delete();
		m_pPtBus = NULL;
		}
}

const bool CPt1Manager::OpenBoard(Device *pDevice)
{
	if(!pDevice)::DebugBreak();

	// {[hI[v
	try{
		// foCXI[v
		if(pDevice->Open() != STATUS_OK)throw __LINE__;
		
		// `[i[uI^Cl[uv
		if(pDevice->SetTunerPowerReset(Device::TUNER_POWER_ON_RESET_ENABLE) != STATUS_OK)throw __LINE__;

		// 20msEFCg
		::Sleep(20UL);

		// `[i[uI^fBZ[uv
		if(pDevice->SetTunerPowerReset(Device::TUNER_POWER_ON_RESET_DISABLE) != STATUS_OK)throw __LINE__;

		// 1msEFCg
		::Sleep(1UL);

		// `[iAȓd͉
		for(DWORD dwTunerID = 0UL ; dwTunerID < TUNER_NUM ; dwTunerID++){		
			// 
			if(pDevice->InitTuner(dwTunerID))throw __LINE__;

			// ȓd͉
			for(DWORD dwTunerType = 0UL ; dwTunerType < Device::ISDB_COUNT ; dwTunerType++){
				if(pDevice->SetTunerSleep(dwTunerID, (Device::ISDB)dwTunerType, false) != STATUS_OK)throw __LINE__;
				}
			}
		}
	catch(...){
		// G[
		pDevice->Close();
		return false;
		}

	return true;
}

void CPt1Manager::CloseBoard(Device *pDevice)
{
	if(!pDevice)::DebugBreak();
	
	// {[hN[Y
	pDevice->Close();
}
